from leapp.libraries.common.config import get_env
from leapp.actors import Actor
from leapp.libraries.stdlib import run, api
from leapp.tags import ChecksPhaseTag, IPUWorkflowTag
from leapp import reporting
from leapp.reporting import Report, create_report
import os.path, shutil

class OSMHprepRepos(Actor):
    """
    Perform preparational work for managed instance upgrade
    """

    name = 'osmhpreprepos'
    consumes = ()
    produces = (Report,)
    tags = (ChecksPhaseTag, IPUWorkflowTag)

    def process(self):
        if not get_env("LEAPP_OSMH"):
            return
        elif get_env("LEAPP_OSMH") == '1':
            self.add_leapp_repo()


    def add_leapp_repo(self):
        leapp_repo_file = '/etc/yum.repos.d/leapp-upgrade-repos-ol9.repo'
        leapp_repo_file_osmh_backup = '/etc/yum.repos.d/leapp-upgrade-repos-ol9.repo.osmh-backup'
        leapp_repo_file_osmh = '/etc/yum.repos.d/osmh-leapp-upgrade-repos-ol9.repo'
        if not os.path.isfile(leapp_repo_file) and os.path.isfile(leapp_repo_file_osmh_backup):
            api.current_logger().warning("leapp repository file %s not found, but it's backup %s found, restoring leapp repository file to proceed with upgrade", leapp_repo_file, leapp_repo_file_osmh_backup)
            shutil.move(leapp_repo_file_osmh_backup, leapp_repo_file)
        return
